/*
 				lf.h

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	Stuff
*
*	Author:		E.BERTIN (IAP)
*
*	Contents:	Include file for lf.c
*
*	Last modify:	12/10/98
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#ifndef	_LF_H_
#define	_LF_H_

/*--------------------------------- constants -------------------------------*/

#define	MABS_MIN	(-20.0)	/* Minimum absolute magnitude - M* */
#define	MABS_MAX	20.0	/* Maximum absolute magnitude - M* */
#define	MABS_NSTEP	1000	/* Number of integration steps */

/*-------------------------- structure definitions --------------------------*/

typedef struct
  {
  double	phistar;	/* Schechter's phi* parameter (m-3) */
  double	mstar;		/* Schechter's M* parameter (mag) */
  double	alpha;		/* Schechter's alpha parameter */
  double	mabsmin,mabsmax;/* Bounds of the LF */
  } lfstruct;


/*-------------------------------- protos -----------------------------------*/

lfstruct	*lf_evol(double z, lfstruct *lf);

double	lf_intschechter(lfstruct *lf, double mmin, double mmax),
	lf_rndschechter(lfstruct *lf, double mmin, double mmax),
	lf_schechter(lfstruct *lf, double m);

#endif
