 /*
 				preflist.h

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	Stuff
*
*	Author:		E.BERTIN (IAP)
*
*	Contents:	Keywords for the configuration file.
*
*	Last modify:	27/01/2005
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#include "key.h"
#ifndef _GALAXIES_H_
#include "galaxies.h"
#endif
#ifndef _STARS_H_
#include "stars.h"
#endif

#ifdef	USE_THREADS
#define	THREADS_PREFMAX THREADS_NMAX
#else
#define	THREADS_PREFMAX 65535
#endif

int idummy;

pkeystruct key[] =
 {
  {"BULGE_FRACTION", P_FLOATLIST, prefs.gal_bt, 0,0, 0.0, 1.0,
   {""}, 1, GAL_MAXNTYPE, &prefs.ngal_bt},
  {"CATALOG_NAME", P_STRINGLIST, prefs.cat_name, 0,0, 0.0,0.0,
   {""}, 1, SED_MAXNPB, &prefs.ncat_name},
  {"COLLECT_AREA", P_FLOATLIST, prefs.area, 0,0, 0.0, BIG,
   {""}, 1, SED_MAXNPB, &prefs.narea},
  {"DATA_DIRECTORY", P_STRING, prefs.datadir_name},
  {"DISK_BETA", P_FLOAT, &prefs.gal_beta, 0,0, 1e-3,100.0},
  {"DISK_EXTINCT", P_FLOATLIST, prefs.gal_iextinc, 0,0, 0.0, BIG,
   {""}, 1, GAL_MAXNTYPE, &prefs.ngal_iextinc},
  {"DISK_RSTAR", P_FLOAT, &prefs.gal_rstar, 0,0, 0.0, 1e12},
  {"DISTANCE_STEP", P_FLOAT, &prefs.integ_zstep, 0,0, 0.0, 10000.0},
  {"EXTINCT_NAME", P_STRING, prefs.extinct_name},
  {"GAIN", P_FLOATLIST, prefs.gain,  0,0, 0.0, BIG,
   {""}, 1, SED_MAXNPB, &prefs.ngain},
  {"GALACTIC_COORDS", P_FLOAT, prefs.galcoord, 0,0, 0.0, 360.0,
   {""}, 2,2, &idummy},
  {"H0", P_FLOAT, &prefs.h0, 0,0, 1.0, 1000.0},
  {"IMAGE_HEIGHT", P_INTLIST, prefs.height, 1, 1000000000, 0.0,0.0,
   {""}, 1, SED_MAXNPB, &prefs.nheight},
  {"IMAGE_WIDTH", P_INTLIST, prefs.width, 1, 1000000000, 0.0,0.0,
   {""}, 1, SED_MAXNPB, &prefs.nwidth},
  {"INCLUDE_STARS", P_BOOL, &prefs.starflag},
  {"LF_ALPHA", P_FLOATLIST, prefs.lf_alpha, 0,0, -100.0, 10.0,
   {""}, 1, GAL_MAXNTYPE, &prefs.nlf_alpha},
  {"LF_MAGLIMITS", P_FLOATLIST, prefs.lf_mlim, 0,0, -100.0, 100.0,
   {""}, 2,2, &idummy},
  {"LF_MSTAR", P_FLOATLIST, prefs.lf_mstar, 0,0, -100.0, 100.0,
   {""}, 1, GAL_MAXNTYPE, &prefs.nlf_mstar},
  {"LF_PHISTAR", P_FLOATLIST, prefs.lf_phistar, 0,0, 0.0, 1e12,
   {""}, 1, GAL_MAXNTYPE, &prefs.nlf_phistar},
  {"MAG_LIMITS", P_FLOATLIST, prefs.maglim, 0,0, -30.0, 50.0,
   {""}, 2,2, &idummy},
  {"OBSDETECT_TYPE", P_KEYLIST, prefs.obsdetect_type, 0,0, 0.0,0.0,
   {"PHOTONS", "ENERGY", ""}, 1, SED_MAXNPB, &prefs.nobsdetect_type},
  {"OMEGA_LAMBDA", P_FLOAT, &prefs.omegal, 0,0, 0.0, 10.0},
  {"OMEGA_M", P_FLOAT, &prefs.omegam, 0,0, 0.0, 10.0},
  {"NTHREADS", P_INT, &prefs.nthreads, 0, THREADS_PREFMAX},
  {"PASSBAND_OBS", P_STRINGLIST, prefs.pb_name, 0,0, 0.0,0.0,
   {""}, 1, SED_MAXNPB, &prefs.npb_name},
  {"PASSBAND_REF", P_STRING, prefs.refpb_name},
  {"PIXEL_SIZE", P_FLOATLIST, prefs.pixscale, 0,0, 1e-3,1e3,
   {""}, 1, SED_MAXNPB, &prefs.npixscale},
  {"REFDETECT_TYPE", P_KEY, &prefs.refdetect_type, 0,0, 0.0,0.0,
   {"PHOTONS", "ENERGY", ""}},
  {"SED_BACKGROUND", P_STRING, prefs.backsed_name},
  {"SED_CALIB", P_STRING, prefs.calibsed_name},
  {"SED_GALAXIES", P_STRINGLIST, prefs.gal_sedname, 0,0, 0.0,0.0,
   {""}, 1, GAL_MAXNSED, &prefs.ngal_sedname},
  {"SED_STARS", P_STRINGLIST, prefs.star_sedname, 0,0, 0.0,0.0,
   {""}, 1, STAR_MAXNSED, &prefs.nstar_sedname},
  {"SEDINDEX_BULGE", P_INTLIST, prefs.gal_bsedno, 1,GAL_MAXNSED+1, 0.0, 0.0,
   {""}, 1, GAL_MAXNTYPE, &prefs.ngal_bsedno},
  {"SEDINDEX_DISK", P_INTLIST, prefs.gal_dsedno, 1,GAL_MAXNSED+1, 0.0, 0.0,
   {""}, 1, GAL_MAXNTYPE, &prefs.ngal_dsedno},
  {"SEED_GALAXIES", P_INT, &prefs.galseed, 0, 0x7fffffffL},
  {"SEED_STARS", P_INT, &prefs.starseed, 0, 0x7fffffffL},
  {"VERBOSE_TYPE", P_KEY, &prefs.verbose_type, 0,0, 0.0,0.0,
   {"QUIET","NORMAL","FULL",""}},

  {""}
 };

char			keylist[sizeof(key)/sizeof(pkeystruct)][32];
static const char	notokstr[] = {" \t=,;\n\r\""};

char *default_prefs[] =
 {
"# Default configuration file for " BANNER " " MYVERSION,
"# EB " DATE,
"#",
" ",
"#--------------------------------- Image -------------------------------------",
" ",
"CATALOG_NAME    g.list,r.list,i.list   # output catalog file name(s)",
"IMAGE_WIDTH     2048            # width of the simulated frame",
"IMAGE_HEIGHT    2048            # height of the simulated frame",
"PIXEL_SIZE      0.2             # pixel size (arcsec)",
"MAG_LIMITS      16.0,28.0       # allowed range of apparent magnitudes",
" ",
"#------------------------ Zero-points and Background -------------------------",
" ",
"COLLECT_AREA    1.0             # Effective collecting area(s) (in m2)",
"GAIN            1.0             # Detector conversion factor(s) (in e-/ADU)",
"SED_BACKGROUND  zodiacal        # Background SED",
" ",
"#-------------------------------- Passbands ----------------------------------",
" ",
"PASSBAND_REF    couch/Bj        # Calibration passband",
"REFDETECT_TYPE  ENERGY          # Ref. detector type: \"PHOTONS\" or \"ENERGY\"",
"PASSBAND_OBS    megaprime/g,megaprime/r,megaprime/i     # Observed passband(s)",
"OBSDETECT_TYPE  PHOTONS         # Obs. detector type: \"PHOTONS\" or \"ENERGY\"",
" ",
"#------------------------------- Cosmology -----------------------------------",
" ",
"H0              70.0            # Hubble constant (km.s-1.Mpc-1)",
"OMEGA_M         0.3             # Matter density in units of critical density",
"OMEGA_LAMBDA    0.7             # Cosmol constant in units of critical density",
"*DISTANCE_STEP   5.0             # Integration step along z (h-1.Mpc)",
" ",
"#----------------------- Spectral Energy Distributions -----------------------",
" ",
"SED_CALIB       AB              # SED that defines the magnitude system",
"SED_GALAXIES    E,Sbc,Scd,Im    # SEDs for galaxy components",
" ",
"SEDINDEX_BULGE  1,1,1,1,1,1     # bulge SED indices in SED_GALAXIES",
"SEDINDEX_DISK   1,1,2,2,3,4     # disk SED indices in SED_GALAXIES",
" ",
"#----------------------------- Galaxy types ----------------------------------",
" ",
"BULGE_FRACTION  1.0,0.57,0.32,0.16,0.049,0.0    # Simien & deVaucouleurs 84",
"                                # B/T in ref. band for each galaxy component",
" ",
"#------------------------ Galaxy luminosity functions ------------------------",
" ",
"LF_PHISTAR      0.6e-3,0.6e-3,3.9e-3,6.9e-3,2.7e-3,1.7e-3",
"                                # Schechter's phi* density parameter (h3.Mpc-3)",
"LF_MSTAR        -19.6,-19.6,-19.6,-19.9,-20.1,-20.1",
"                                # Schechter's M* absolute magnitude",
"LF_ALPHA        -0.7,-0.7,-0.7,-1.1,-1.5,-1.5",
"                                # Schechter's alpha parameter",
"LF_MAGLIMITS    -25.0,-15.0     # bounds to the luminosity function",
" ",
"#------------------------------- Extinction ----------------------------------",
" ",
"EXTINCT_NAME    LMC.ext         # Internal extinction law",
"DISK_EXTINCT    0.0,0.75,1.23,1.47,1.47,1.23",
"                                # de Vaucouleurs' alpha (extinction parameter)",
" ",
"#------------------------------- Disk sizes ----------------------------------",
" ",
"DISK_BETA       3.0             # Beta parameter of the disk size distribution",
"DISK_RSTAR      2600            # r* parameter of the disk size distribution",
"                                # (see de Jong & Lacey 2000)",
" ",
"#------------------------------ Stellar field --------------------------------",
" ",
"INCLUDE_STARS   N               # allow addition of a stellar field?",
"GALACTIC_COORDS 270,30.0        # galactic coordinates",
"*SED_STARS      Vega            # stellar SEDs",
" ",
"#----------------------------- Random Seeds ----------------------------------",
" ",
"SEED_STARS      0               # random seed for the stellar field (0=time)",
"SEED_GALAXIES   0               # random seed for the galaxy field (0=time)",
" ",
"#----------------------------- Miscellaneous ---------------------------------",
" ",
"DATA_DIRECTORY  data            # Top of directory tree containing Stuff data",
"VERBOSE_TYPE    NORMAL          # \"QUIET\",\"NORMAL\", \"LOG\" or \"FULL\"",
#ifdef USE_THREADS
"NTHREADS        0               # Number of simultaneous threads for the SMP",
"                                # version of " BANNER " (0 = automatic)",
#else
"NTHREADS        1               # 1 single thread",
#endif
""};

